<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/14/2003 *
 * ===================                          Last change: 11/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : mailid_top.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Confirmation file for emails                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bestaetigung von Mails                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here
require('inc/libs/security_functions.php');

// Init start time
$GLOBALS['startTime'] = microtime(true);

// Tell everyone we are in this module
$GLOBALS['module'] = 'mailid';
$GLOBALS['output_mode'] = -1;

// Load the required file(s)
require('inc/config-global.php');

// Set content type
setContentType('text/html');

// Is the extension mailid active?
redirectOnUninstalledExtension('mailid');

// Is the extension other active?
redirectOnUninstalledExtension('other');

// Init variables
$url_userid = '0';
$url_bid = '0';
$url_mid = '0';
$code = '0';
$mode = '';

// Secure all data
if (isGetRequestParameterSet('userid'))  $url_userid = bigintval(getRequestParameter('userid'));
if (isGetRequestParameterSet('mailid'))  $url_mid    = bigintval(getRequestParameter('mailid'));
if (isGetRequestParameterSet('bonusid')) $url_bid    = bigintval(getRequestParameter('bonusid'));
if (isGetRequestParameterSet('code'))    $code       = bigintval(getRequestParameter('code'));
if (isGetRequestParameterSet('mode'))    $mode       = getRequestParameter('mode');

// 01           1        12            2    2            21    1                   22     10
if ((isValidUserId($url_userid)) && (($url_mid > 0) || ($url_bid > 0)) && (!ifFatalErrorsDetected())) {
	// No image? Then output header
	if ($mode != 'img') loadIncludeOnce('inc/header.php');

	// Maybe he wants to confirm an email?
	if ($url_mid > 0) {
		$result_main = SQL_QUERY_ESC("SELECT `id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `stats_id`=%s AND `userid`=%s LIMIT 1",
			array($url_mid, $url_userid), __FILE__, __LINE__);
		$type = 'mailid'; $urlId = $url_mid;
	} elseif ($url_bid > 0) {
		$result_main = SQL_QUERY_ESC("SELECT `id`, `link_type` FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `bonus_id`=%s AND `userid`=%s LIMIT 1",
			array($url_bid, $url_userid), __FILE__, __LINE__);
		$type = 'bonusid'; $urlId = $url_bid;
	}

	if (SQL_NUMROWS($result_main) == 1) {
		// Is the stats id valid?
		list($lid, $ltype) = SQL_FETCHROW($result_main);

		// Init result here with invalid to avoid possible missing variable
		$result_mailid = false;

		// @TODO Rewrite this to a filter
		switch ($ltype) {
			case 'NORMAL':
				$result_mailid = SQL_QUERY_ESC("SELECT `pool_id`, `userid`, `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `id`=%s LIMIT 1",
					array($url_mid), __FILE__, __LINE__);
				break;

			case 'BONUS':
				$result_mailid = SQL_QUERY_ESC("SELECT `id`, `id`, `is_notify` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
					array($url_bid), __FILE__, __LINE__);
				break;

			default: // Unknown type
				debug_report_bug(__FILE__, __LINE__, 'Unknown mail type ' . $ltype . ' detected.');
				break;
		}

		// Entry found?
		if (SQL_NUMROWS($result_mailid) == 1) {
			// Load data
			list($pool, $sender, $notify) = SQL_FETCHROW($result_mailid);

			// Correct notification switch in non-bonus mails
			if (($notify != 'Y') && ($notify != 'N')) $notify = 'N';

			// Set sender to 0 when we have a bonus mail
			if ($ltype == 'BONUS') $sender = '0';

			// Is the user id valid?
			if (fetchUserData($url_userid) === true) {
				// Is the user status CONFIRMED?
				if (getUserData('status') == 'CONFIRMED') {
					// User has confirmed his account so we can procede...
					// @TODO Rewrite this to a filter
					switch ($ltype) {
						case 'NORMAL':
							$result = SQL_QUERY_ESC("SELECT `payment_id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s LIMIT 1",
								array(bigintval($pool)), __FILE__, __LINE__);

							// Entry found?
							if (SQL_NUMROWS($result) == 1) {
								list($pay) = SQL_FETCHROW($result);
								$time      = getPaymentPoints($pay, 'time');
								$payment   = getPaymentPoints($pay, 'payment');
								$isValid   = true;
							} // END - if

							// Free memory...
							SQL_FREERESULT($result);
							break;

						case 'BONUS':
							$result = SQL_QUERY_ESC("SELECT `time`, `points` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
								array(bigintval($pool)), __FILE__, __LINE__);

							// Entry found?
							if (SQL_NUMROWS($result) == 1) {
								list($time, $payment) = SQL_FETCHROW($result);
								$isValid = true;
							} // END - if

							// Free memory...
							SQL_FREERESULT($result);
							break;

						default: // Unknown type
							debug_report_bug(__FILE__, __LINE__, 'Unknown mail type ' . $ltype . ' detected.');
							break;
					}

					// Is this entry valid?
					if ($isValid === true) {
						if (($time == '0') && ($payment > 0)) $time = 1;
						if (($time > 0) && ($payment > 0)) {
							$img_code = '0';
							if (!empty($code)) {
								// Generate code
								$img_code = generateRandomCode(getConfig('code_length'), $code, $url_userid, $urlId);
							} // END - if

							// @TODO Rewrite this to a filter
							switch ($mode) {
								case 'add':
									// Init stats data
									$stats_data = '0';

									// Count clicks
									// @TODO Rewrite this to a filter
									switch ($ltype) {
										case 'NORMAL':
											SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_stats` SET `clicks`=`clicks`+1 WHERE `id`=%s LIMIT 1",
												array($url_mid), __FILE__, __LINE__);

											// Update mediadata as well
											if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
												// Update database
												updateMediadataEntry(array('total_clicks', 'normal_clicks'), 'add', 1);
											} // END - if
											$stats_data = $url_mid;
											break;

										case 'BONUS':
											SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_bonus` SET `clicks`=`clicks`+1 WHERE `id`=%s LIMIT 1",
												array($url_bid), __FILE__, __LINE__);

											// Update mediadata as well
											if (isExtensionInstalledAndNewer('mediadata', '0.0.4')) {
												// Update database
												updateMediadataEntry(array('total_clicks', 'bonus_clicks'), 'add', 1);
											} // END - if
											$stats_data = $url_bid;
											break;

										default: // Unknown type
											debug_report_bug(__FILE__, __LINE__, 'Unknown mail type ' . $ltype . ' detected.');
											break;
									} // END - switch

									// Export data into constants for the template
									$content['points'] = translateComma($payment);
									$content['banner'] = loadTemplate('mailid_banner', true);

									// Only when user extension = v0.1.2: Update mails-confirmed counter
									// @TODO Rewrite these blocks to filter
									if (isExtensionInstalledAndNewer('user', '0.1.2')) {
										// Update counter
										SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET mails_confirmed=mails_confirmed + 1 WHERE `userid`=%s LIMIT 1",
											array($url_userid), __FILE__, __LINE__);

										// Update random confirmed as well?
										if (isExtensionInstalledAndNewer('user', '0.3.4')) {
											// Update second counter
											SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `rand_confirmed`=`rand_confirmed` + 1 WHERE `userid`=%s LIMIT 1",
												array($url_userid), __FILE__, __LINE__);
										} // END - if
									} // END - if

									// Insert stats record
									insertUserStatsRecord($url_userid, $type, $stats_data);

									// Right code entered?
									if (bigintval(postRequestParameter('gfx_check')) == $img_code) {
										// Add points over referal system is the default
										$locked = false;
										$template = 'mailid_points_done';

										// Right code entered add points and remove entry
										if ((getUserData('ref_payout') > 0) && (getConfig('allow_direct_pay') != 'Y')) {
											// Don't add points over the referal system
											$locked = true;
											$template = 'mailid_points_locked';
										} // END - if

										// Count down ref_payout value
										SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `ref_payout`=`ref_payout`-1 WHERE `userid`=%s AND `ref_payout` > 0 LIMIT 1",
											array($url_userid), __FILE__, __LINE__);

										// Add points
										// @TODO Try to rewrite the following unset()
										unset($GLOBALS['ref_level']);
										addPointsThroughReferalSystem('mailid_okay', $url_userid, $payment, false, 0, $locked);

										// Shall I add bonus points for "turbo clickers" ?
										if (isExtensionInstalledAndNewer('bonus', '0.2.2')) {
											// Is an active-rallye running and this is not a notification mail?
											if ((isBonusRallyeActive()) && ($notify != 'Y')) {
												// Shall I exclude the webmaster's own userid from the active-rallye?
												if ((((getBonusUserId() == $url_userid) && (getConfig('bonus_include_own') == 'Y')) || (getBonusUserId() != $url_userid)) && (getConfig('def_refid') != $url_userid)) {
													// Add points and remember ranking are done in this function....
													addTurboBonus($urlId, $url_userid, $type);

													// Set template to mailid_points_done2 which contains a link to the ranking list
													$template = 'mailid_points_done2';
													if ($locked) $template = 'mailid_points_locked2';
													$content['userid']  = $url_userid;
													$content['type']    = $type;
													$content['data']    = $urlId;
												} // END - if
											} // END - if
										} // END - if

										// Load total points
										$content['total'] = translateComma(
											countSumTotalData($url_userid, 'user_points', 'points') -
											countSumTotalData($url_userid, 'user_data', 'used_points')
										);

										// Load template
										loadTemplate($template, false, $content);
									} elseif (isValidUserId($sender)) {
										// Wrong image code! So add points to sender's account
										addPointsDirectly('mailid_payback', $sender, $payment);

										// Load template
										loadTemplate('mailid_points_failed', false, $content);
									}

									// Remove link from table
									SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `id`=%s LIMIT 1",
										array(bigintval($lid)), __FILE__, __LINE__);
									break;

								case 'img':
									generateImageOrCode($img_code);
									break;

								case 'confirm':
									if ($code > 0) {
										// Export data into constants for the template
										$content['code']   = $code;
										$content['userid'] = $url_userid;
										$content['type']   = $type;
										$content['data']   = $urlId;
										$content['banner'] = loadTemplate('mailid_banner', true);
										if (getConfig('code_length') > 0) {
											// Generate Code
											$content['image'] = generateCaptchaCode($code, $type, $urlId, $url_userid);
											$templ = 'mailid_enter_code';
										} else {
											// Disabled code
											$content['gfx'] = $img_code;
											$templ = 'mailid_confirm_buttom';
										}

										// Load template
										loadTemplate($templ, false, $content);
									} else {
										// Cannot confirm!
										debug_report_bug(__FILE__, __LINE__, 'No code given.');
									}
									break;

								case '':
									// Ok, all data is valid and loaded. Finally let's output the timer... :-)
									// Export data into constants for the template
									$content['time']   = $time;
									$content['tim2']   = strlen($time);
									$content['userid'] = $url_userid;
									$content['type']   = $type;
									$content['data']   = $urlId;
									$content['rand']   = mt_rand(0, 99999);
									$content['banner'] = loadTemplate('mailid_banner', true);

									// Load template
									loadTemplate('mailid_timer', false, $content);
									break;

								default: // Unknown mode
									debug_report_bug(__FILE__, __LINE__, 'Unknown mode ' . $mode . ' detected.');
									break;
							} // END - switch
						} else {
							loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (6)</div>');
							$mode = 'failed';
						}
					} else {
						loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (5)</div>');
						$mode = 'failed';
					}
				} else {
					loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (4)</div>');
					$mode = 'failed';
				}
			} else {
				loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (3)</div>');
				$mode = 'failed';
			}
		} else {
			loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (2)</div>');
			$mode = 'failed';
		}

		// Free result
		SQL_FREERESULT($result_mailid);
	} else {
		loadTemplate('admin_settings_saved', false, '<div class="member_failed">{--MAIL_ALREADY_CONFIRMED--} (1)</div>');
		$mode = 'failed';
	}

	// Free result
	SQL_FREERESULT($result_main);

	// Insert footer if no image
	if ($mode != 'img') {
		// Write footer
		loadIncludeOnce('inc/footer.php');
	} // END - if
}

// Really all done here... ;-)
shutdown();

// [EOF]
?>
